/* 
 * === Slider Class ===
 * 
 * updated 2003/07/02
 * 
 * mail : peace@skipup.com
 * home : http://www.skipup.com/~peace/
 */



/**
 * 
 */
function class__Slider__(window){
	var classId = Object.getClassName(arguments.callee);

	/**
	 * Slider(int orientation, Dimension size, Point3 position)
	 * 
	 * Slider(int orientation, Point3 position)
	 * 	size = [100, 10];
	 * 
	 * Slider(Point3 position)
	 * 	orientation = HORIZONTAL
	 * 	size = [100, 10];
	 */
	var F = window[classId] = function(){
		if (this.constructor !== F)
			this.constructor = F;

		var position = new Point3();
		this.$size = new Dimension();

		var a = arguments;
		switch (a.length) {
			case 3 :
				this.$orientation = a[0];
				this.$size.set(a[1]);
				position.set(a[2]);
				break;
			case 2 :
				this.$orientation = a[0];
				position.set(a[1]);
				this.$size.set(100, 10);
				break;
			case 1 :
				this.$orientation = F.HORIZONTAL;
				position.set(a[0]);
				this.$size.set(100, 10);
				break;
		}

		/**
		 * j[NIDD
		 */
		this.$id = ID + new Date().getTime();

		for (var i = 0; i < ELEMENTS_ID.length; i++) {
			var elementId = ELEMENTS_ID[i];
			var spanId = this.$id + "_" + elementId.toUpperCase();

			document.writeln(
				"<span"
				+ (" id=\"" + spanId + "\"")
				+ " style=\"position:absolute;visibility:hidden;\""
				+ "><\/span>");

			this["$" + elementId] = new JElement(spanId);
			this["$" + elementId].toLaserElement();
		}

		/**
		 * Q[WlD
		 * 0.0 <= value <= 1.0D
		 */
		this.$value = 0.0;

		this.setSize(this.$size);

		this.setPosition(position.x, position.y);
		this.setZ(position.z);

		this.$eBorder.setBackgroundColor("333333");
		this.$eShadow.setBackgroundColor("999999");
		this.$eBg.setBackgroundColor("ccccdd");
		this.$eBlight.setBackgroundColor("ffffff");
		this.$eGauge.setBackgroundColor("9999cc");

		this.setVisibility(true);

		this.$innerListener__MouseDown = null;
		this.$innerListener__MouseMove = null;
		this.$innerListener__MouseUp = null;

		/**
		 * }EX삪LCD
		 * ^̂ƂLD
		 */
		this.$enable = true;

		/**
		 * hbÔƂ^D
		 */
		this.$dragging = false;

		var me = this;

		// Xi[̐ݒD
		{
			this.$eSensor.setEventListener(
				"mousedown",
				function(e) {me.$mouseDown(e);});
			CLIENT.addEventListener(
				"mousemove",
				function(e) {me.$mouseMove(e);});
			CLIENT.addEventListener(
				"mouseup",
				function(e) {me.$mouseUp(e);});

			if (CLIENT.ie) {
				this.$eSensor.layer.onselectstart = function() {
					window.event.returnValue = false;
					return false;
				};
			}
		}
	};

	var FP = F.prototype;

	var ID = "EUGRACE_" + classId.toUpperCase();

	var CLIENT = new JClient(window);

	var ELEMENTS_ID = new Array(
		"eBorder", "eShadow", "eBg", "eBlight", "eGauge", "eSensor");

	/**
	 * XC_̕io[jD
	 */
	F.HORIZONTAL = 0;

	/**
	 * XC_̕io[jD
	 */
	F.VERTICAL = 1;

	/**
	 * Cxgݒp}XND
	 */
	F.MOUSEDOWN = 1;
	F.MOUSEUP = 2;
	F.MOUSEMOVE = 4;

	/**
	 * }EX̗L^ݒD
	 * ^̂ƂLɂD
	 */
	FP.setEnable = function(b) {
		this.$enable = Boolean(b);
	};

	/**
	 * void setEventListener(int eventType, function listener)
	 */
	FP.setEventListener = function(eventType, listener) {
		if((eventType & F.MOUSEDOWN) != 0)
			this.$innerListener__MouseDown = listener;
		if((eventType & F.MOUSEMOVE) != 0)
			this.$innerListener__MouseMove = listener;
		if((eventType & F.MOUSEUP) != 0)
			this.$innerListener__MouseUp = listener;
	};

	/**
	 * void clearEventListener(int eventType)
	 */
	FP.clearEventListener = function(eventType) {
		if((eventType & F.MOUSEDOWN) != 0)
			this.$innerListener__MouseDown = null;
		if((eventType & Action.MOUSEMOVE) != 0)
			this.$innerListener__MouseMove = null;
		if((eventType & Action.MOUSEUP) != 0)
			this.$innerListener__MouseUp = null;
	};

	/**
	 * Q[WlݒD
	 * double setValue(double value)
	 * Cxgnh͋NȂD
	 * @return	Q[WlD0.0 <= returnValue <= 1.0
	 */
	FP.setValue = function(v) {
		this.$value = v < 0.0 ? 0.0 : (v > 1.0 ? 1.0 : v);

		if (this.$orientation == F.HORIZONTAL)
			this.$eGauge.setWidth(this.$value * this.$size.width);
		else
			this.$eGauge.setHeight(this.$value * this.$size.height);

		return this.$value;
	};

	/**
	 * Q[Wl̎擾D
	 */
	FP.getValue = function() {
		return this.$value;
	};

	FP.$setValueWithEvent = function(evt) {
		if (this.$orientation == F.HORIZONTAL) {
			var w = evt.getAbsoluteX() - this.$eGauge.getX();
			if (w < 0)
				w = 0;
			else if (w > this.$size.width)
				w = this.$size.width;

			this.$eGauge.setWidth(w);

			this.$value = w / this.$size.width;
		} else {
			var h = evt.getAbsoluteY() - this.$eGauge.getY();
			if (h < 0)
				h = 0;
			else if (h > this.$size.height)
				h = this.$size.height;

			this.$eGauge.setHeight(h);

			this.$value = h / this.$size.height;
		}
	};

	FP.$mouseDown = function(e) {
		if (!this.$enable)
			return;

		this.$setValueWithEvent(new JEvent(e));

		this.$dragging = true;

		if (this.$innerListener__MouseDown != null)
			this.$innerListener__MouseDown(this.$value);
	};

	FP.$mouseMove = function(e) {
		if (!this.$enable || !this.$dragging)
			return;
		
		this.$setValueWithEvent(new JEvent(e));

		if(this.$innerListener__MouseMove != null)
			this.$innerListener__MouseMove(this.$value);
	};

	FP.$mouseUp = function(e) {
		if (!this.$enable || !this.$dragging)
			return;

		this.$dragging = false;

		if (this.$innerListener__MouseUp != null)
			this.$innerListener__MouseUp(this.$value);
	};

	/**
	 * XC_̃TCYݒD
	 * void f(int w, int h)
	 * void f(Dimension size)
	 * Q[WGgD
	 */
	FP.setSize = function() {
		var a = arguments;

		var w, h;
		switch (a.length) {
			case 1 :
				w = a[0].width;
				h = a[0].height;
				break;
			case 2 :
				w = a[0];
				h = a[1];
				break;
		}

		this.$size.set(w, h);

		this.$eBorder.setSize(w + 2, h + 2);
		this.$eShadow.setSize(w, h);
		this.$eBg.setSize(w - 1, h - 1);
		this.$eBlight.setSize(w + 2, h + 2);
		if (this.$orientation == F.HORIZONTAL)
			this.$eGauge.setSize(this.$value * w, h);
		else
			this.$eGauge.setSize(w, this.$value * h);
		this.$eSensor.setSize(w + 3, h + 3);
	};

	/**
	 * XC_̈ʒuݒD
	 * void setPosition(int x, int y)
	 * void setPosition(Point position)
	 * Q[WGgD
	 */
	FP.setPosition = function() {
		var a = arguments;

		var x, y;
		switch (a.length) {
			case 1 :
				x = a[0].x;
				y = a[0].y;
				break;
			case 2 :
				x = a[0];
				y = a[1];
				break;
		}

		this.$eBorder.setPosition(x - 1, y - 1);
		this.$eShadow.setPosition(x, y);
		this.$eBg.setPosition(x + 1, y + 1);
		this.$eBlight.setPosition(x, y);
		this.$eGauge.setPosition(x, y);
		this.$eSensor.setPosition(x - 1, y - 1);
	};

	/**
	 * XC_ZWݒD
	 * void setZ(int zIndex)
	 * XC_\SGgŁC
	 * ԉɂGgZ-INDEX(zIndex)ɐݒ肷D
	 */
	FP.setZ = function(z) {
		this.$eBorder.setZ(z + 1);
		this.$eShadow.setZ(z + 2);
		this.$eBg.setZ(z + 3);
		this.$eBlight.setZ(z);
		this.$eGauge.setZ(z + 4);
		this.$eSensor.setZ(z + 5);
	};

	/**
	 * XC_̈ʒu擾D
	 * Point getPosition()
	 * Q[WGg̈ʒu擾邱ƂɒӁD
	 */
	FP.getPosition = function() {
		return this.$eGauge.getPosition();
	};

	/**
	 * XC_ZW擾D
	 * int getZ()
	 * XC_\SGgŁC
	 * ԉɂGgZ-INDEX擾D
	 */
	FP.getZ = function() {
		return this.$eBlight.getZ();
	};

	/**
	 * 
	 */
	FP.setVisibility = function(v) {
		this.$eBorder.setVisibility(v);
		this.$eShadow.setVisibility(v);
		this.$eBg.setVisibility(v);
		this.$eBlight.setVisibility(v);
		this.$eGauge.setVisibility(v);
		this.$eSensor.setVisibility(v);
	};

	/**
	 * 
	 */
	FP.setBorderColor = function(color) {
		this.$eBorder.setBackgroundColor(color);
	};

	/**
	 * 
	 */
	FP.setShadowColor = function(color) {
		this.$eShadow.setBackgroundColor(color);
	};

	/**
	 * 
	 */
	FP.setBackgroundColor = function(color) {
		this.$eBg.setBackgroundColor(color);
	};

	/**
	 * 
	 */
	FP.setBlightColor = function(color) {
		this.$eBlight.setBackgroundColor(color);
	};

	/**
	 * 
	 */
	FP.setGaugeColor = function(color) {
		this.$eGauge.setBackgroundColor(color);
	};
} class__Slider__(window);

